﻿Type=StaticCode
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Public ImgList As List          'list of all the found images complete of absolute path
	Private ImgTypeNumber As Int    'number of different image types searched
End Sub

'Search all the listed types
Sub CollectImagesAll
	ImgList.Initialize
	ImgTypeNumber = 3
	CollectImageType("png")
	CollectImageType("jpg")
	CollectImageType("bmp")
End Sub

'Search for a specific image type
Private Sub CollectImageType(iType As String)
	Dim shl As Shell
	shl.Initialize("shltst","cmd",Array As String("/C","dir","/b","/s","c:\*."&iType))
	shl.WorkingDirectory="C:\"
	shl.Run(50000) 'try 50 seconds or use -1 to give it all the time it's needed (e.g. no timeout)
End Sub

'Called as many times as we have image types
Private Sub shltst_ProcessCompleted (Success As Boolean, ExitCode As Int, StdOut As String, StdErr As String)
   If Success And ExitCode = 0 Then
     Log("Success")
     Log(StdOut)                      'better to comment out in production
		 'insert valid data in ImgList
		 Dim separator As String
		 separator = Chr(13)&Chr(10)
     ImgList.AddAll(Regex.Split(separator,StdOut))
   Else
     Log("Error: " & StdErr)
   End If
	 ImgTypeNumber=ImgTypeNumber -1
	 If ImgTypeNumber = 0 Then 
	 	 Log("Process ended")
		 Log("Number of found images: "&ImgList.Size)
		 'here is the place for a callback function
	End If
End Sub